'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _open = require('open');

var _open2 = _interopRequireDefault(_open);

var _randomstring = require('randomstring');

var _path = require('path');

var _request = require('request');

var _request2 = _interopRequireDefault(_request);

var _stringTemplate = require('string-template');

var _stringTemplate2 = _interopRequireDefault(_stringTemplate);

var _logger = require('../utils/logger');

var _logger2 = _interopRequireDefault(_logger);

var _readme = require('../utils/readme');

var _readme2 = _interopRequireDefault(_readme);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Internal dependencies
 */
/**
 * External dependencies
 */
exports.default = function () {
	try {
		runPreview(_readme2.default.mustGetContent(['README.md', 'readme.md']));
	} catch (e) {
		_logger2.default.error(e.toString());
	}
};

function runPreview(readmeMd) {
	var req = {
		method: 'POST',
		url: 'https://api.github.com/markdown/raw',
		headers: {
			'Content-Type': 'text/plain',
			'User-Agent': 'gedex/wpt'
		},
		body: readmeMd
	};
	(0, _request2.default)(req, preview);
}

function preview(err, resp, body) {
	if (err) {
		return _logger2.default.error(err.message);
	}

	if (200 !== resp.statusCode) {
		return _logger2.default.error('Unexpected status code ' + resp.statusCode + ' from GitHub.');
	}

	openBrowser(writeTempHtml(body.toString()));
}

function writeTempHtml(readmeMd) {
	var tmpHtml = (0, _path.resolve)(process.cwd(), (0, _randomstring.generate)() + '.index.html');
	var tplDir = (0, _path.resolve)(__dirname, '../../static/preview-gh');
	var out = (0, _stringTemplate2.default)(_fsExtra2.default.readFileSync((0, _path.resolve)(tplDir, 'index.html'), 'utf8'), {
		css: _fsExtra2.default.readFileSync((0, _path.resolve)(tplDir, 'style.css')),
		readme: readmeMd
	});
	_fsExtra2.default.writeFileSync(tmpHtml, out, 'utf8');
	return tmpHtml;
}

function openBrowser(tmpHtml) {
	(0, _open2.default)(tmpHtml, function (err) {
		if (!err) {
			setTimeout(function () {
				_fsExtra2.default.removeSync(tmpHtml);
			}, 3000);
		}
	});
}
module.exports = exports['default'];